-- thanks to evl

local font, fontsize, fontoutline = 'Interface\\AddOns\\waStats\\SEMPRG__.TTF', 8, 'OUTLINE'
local movable = false -- false/true

local statsframe = CreateFrame('Button', 'StatsTextFrame', UIParent)
statsframe:SetFrameStrata'BACKGROUND'
statsframe:SetFrameLevel(0)
statsframe:SetWidth(160)
statsframe:SetHeight(50)
if movable == false then
	statsframe:ClearAllPoints()
	statsframe:SetPoint('BOTTOM', UIParent, "BOTTOM", 0, 0)
end
statsframe:EnableMouse(true)
statsframe:RegisterForClicks('AnyUp')

if movable == true then
	statsframe:SetClampedToScreen(true)
	statsframe:SetMovable(true)
	statsframe:SetUserPlaced(true)
	statsframe:SetScript('OnMouseDown', function()
		if(IsAltKeyDown()) then
			statsframe:ClearAllPoints()
			statsframe:StartMoving()
		end
	end)
	statsframe:SetScript('OnMouseUp', function()
		statsframe:StopMovingOrSizing()
	end)
end

local statstext = statsframe:CreateFontString(nil, 'OVERLAY')
statstext:SetPoint('CENTER', statsframe, 0, 0) 
statstext:SetHeight(12) 
statstext:SetWidth(160)
statstext:SetTextColor(1, 1, 1) 
statstext:SetFont(font, fontsize, fontoutline)

local colorlag = function(number)
	if number <= 100 then
		return '|cff00ff00'
	elseif number <= 200 then
		return '|cffffff00'
	else
		return '|cffff0000'
	end
end

local colorfps = function(number)
	if number >= 30 then
		return '|cff00ff00'
	elseif number < 30 then
		return '|cffffff00'
	elseif number < 15 then
		return '|cffff0000'
	end
end

local AddonsMemoryCompare = function(a, b)
	return a.memory > b.memory
end

local FormatMemoryNumber = function(number)
	if number > 1000 then
		return string.format('%.2f mb', number / 1000)
	else
		return string.format('%.1f kb', number)
	end
end

local interval = 0
statsframe:SetScript('OnUpdate', function(self, elapsed)
	interval = interval - elapsed
	if interval <= 0 then
		local fps = GetFramerate()
		local latency = select(3,GetNetStats())
		statstext:SetText(string.format('%s%d|r fps %s%d|r ms', colorfps(fps), fps, colorlag(latency), latency))
		interval = 1
	end
end)

local memoryFormat = '%.2f %s'
local addons, totalMemory
local memory, addon, i
statsframe:SetScript('OnEnter', function()
	addons = {}
	totalMemory = 0
	
	UpdateAddOnMemoryUsage()	
	GameTooltip:SetOwner(statsframe, 'ANCHOR_BOTTOMRIGHT')

	for i=1, GetNumAddOns(), 1 do
		memory = GetAddOnMemoryUsage(i)
		addon = {name = GetAddOnInfo(i), memory = memory}
		table.insert(addons, addon)
		
		totalMemory = totalMemory + memory
	end
	
	table.sort(addons, AddonsMemoryCompare)
	
	i = 0
	for _, addon in pairs(addons) do
		GameTooltip:AddDoubleLine(addon.name, FormatMemoryNumber(addon.memory), 1, 1, 1, 1, 1, 1)
		
		i = i + 1
		
		if i >= 10 then
			break
		end
	end
	
	GameTooltip:AddLine('\n')
	GameTooltip:AddDoubleLine('Total', FormatMemoryNumber(totalMemory), 1, 1, 0, 1, 1, 0)
	
	GameTooltip:AddLine('Hint: Click to collect garbage!', 1, 1, 0)
	
	GameTooltip:Show()
end)
statsframe:SetScript('OnLeave', function()
	GameTooltip:Hide()
end)

statsframe:SetScript('OnClick', function()
	local oldcount = collectgarbage('count')
	collectgarbage()
	local count = collectgarbage('count')
	print(FormatMemoryNumber(oldcount - count)..' garbage was collected.')
end)